<%@ page import="com.ether.EtherPlotServiceImpl" %>
<script type="text/javascript">
var InterfaceVisualization = Class.create( {

    initialize: function( jsonPlateforms, axeTypesForFixedPlateforms, axeTypesForMobilePlateforms )
    {
        // Values
        this.parent = $( "txt" );
        this.superParent = $( "pageContent" ); // need to resize in function of containerParameters
        this.generalContainerPlateforms = $( "generalContainerPlateforms" );
        this.generalContainerParameters = $( "generalContainerParameters" );
        this.generalContainerOptions = $( "generalContainerOptions" );
        this.jsonPlateforms = jsonPlateforms || null;
        this.jsonAxeTypesForFixedPlateforms = axeTypesForFixedPlateforms || null;
        this.jsonAxeTypesForMobilePlateforms = axeTypesForMobilePlateforms || null;
        this.selectedPlateform = false;
        this.selectedParameter = false;
        this.beginDate = false;
        this.endDate = false;
        this.numberParameterToDisplay = 0;

        /** *********** CONTAINERS *********** **/
        this.containerPlateforms = $( "containerPlateforms" );
        this.containerParameters = $( "containerParameters" );
        this.containerButtons = $( "containerButtons" );
        this.containerOptionCalendar = $( "containerOptionCalendar" );
        this.containerOptionType = $( "containerOptionType" );
        this.containerOptionPlotsSelect = $( "containerOptionPlotsSelect" );
        this.containerOptionPlotsButtons = $( "containerOptionPlotsButtons" );

        /** *********** LOADING *********** **/
        // Create loading object for plateforms
        var param = new Object();
        param.id = "loadingForPlateforms";
        param.parent = this.containerPlateforms;
        this.loadingPlateforms = new Loading( param );
        this.loadingPlateforms.display();

        // Create loading object for parameters
        var param = new Object();
        param.id = "loadingForParameters";
        param.parent = this.containerParameters;
        this.loadingParameters = new Loading( param );
        this.loadingParameters.display();

        /** *********** WINDOW FOR THE PLOT *********** **/
        this.plotWindow = new Window( {className: "dialog", zIndex: 100,
            resizable: true, draggable:true, wiredDrag: true,
            showEffect:Effect.BlindDown, hideEffect: Effect.SwitchOff } );
        this.plotWindow.setTitle( interfaceTexts["app.title"] + "-" + interfaceTexts["data.visualization.quicklook"] );

        this.createOptions();
        this.displayPlateforms();
    },

    // CREATES ********************************************************
    createOptions: function()
    {
        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( "beginDate", { format: this.calendarFormat, firstDOW: 1,
            labelTitle: interfaceTexts["data.visualization.selectDate"], labelYear: interfaceTexts["data.visualization.selectYear"], labelMonth: interfaceTexts["data.visualization.selectMonth"], labelDayOfMonth: interfaceTexts["data.visualization.selectDay"],
            labelHour: interfaceTexts["data.visualization.selectHour"], labelMinute: interfaceTexts["data.visualization.selectMinute"],
            methodToCall: this.onClickBeginDate.bindAsEventListener( this )
        } );

        AnyTime.picker( "endDate", { format: this.calendarFormat, firstDOW: 1,
            labelTitle: interfaceTexts["data.visualization.selectDate"], labelYear: interfaceTexts["data.visualization.selectYear"], labelMonth: interfaceTexts["data.visualization.selectMonth"], labelDayOfMonth: interfaceTexts["data.visualization.selectDay"],
            labelHour: interfaceTexts["data.visualization.selectHour"], labelMinute: interfaceTexts["data.visualization.selectMinute"],
            idToUpdateEarliest: "beginDate"
        } );

        this.clearCalendarButton = new Button( {value:interfaceTexts["data.visualization.button.clear"], parent:this.containerOptionCalendar, id:"button_clear_calendar", className:"small", onClick:this.onClickClear.bind( this )} );

        // Buttons and axe's types
        this.createButtons();
        this.createListTypes();
        this.createListPlots();
    },

    createButtons: function()
    {
        this.visualizeButton = new Button( {value:interfaceTexts["data.visualization.button.visualize"], parent:this.containerButtons, id:"button_visualize", onClick:this.onClickVisualize.bind( this )} );
//        this.visualizeButton.disable();
        this.downloadButton = new Button( {value:interfaceTexts["data.visualization.button.download"], parent:this.containerButtons, id:"button_download", onClick:this.onClickDownload.bind( this )} );
        this.downloadButton.disable();
    },

    createListTypes: function()
    {
        var paramSelect = new Object();
        paramSelect.id = "select_axes";
        paramSelect.parent = this.containerOptionType;
        this.selectAxes = new Select( paramSelect );
    },

    createListPlots: function()
    {
        var paramSelect = new Object();
        paramSelect.id = "select_plots";
        paramSelect.parent = this.containerOptionPlotsSelect;
        paramSelect.classNameOption = "select_plot_option";
        this.selectPlots = new Select( paramSelect );
        this.selectPlots.add( null, interfaceTexts["data.visualization.graph.noPlot"] );
        this.selectPlots.selectFirst( false );

        this.selectPlotsPlateformType = false;

        this.addPlotButton = new Button( {value:interfaceTexts["data.visualization.add"], parent:this.containerOptionPlotsButtons, id:"button_add_plot", className:"small", onClick:this.onClickAddPlot.bind( this ), onMouseOver:this.onMouseOverAddPlot.bind( this ), onMouseOut:this.onMouseOutAddPlot.bind( this )} );
        this.addPlotButton.disable();
        this.initPlotButton = new Button( {value:interfaceTexts["data.visualization.button.init"], parent:this.containerOptionPlotsButtons, id:"button_init_plot", className:"small", onClick:this.onClickInitPlot.bind( this ), onMouseOver:this.onMouseOverInitPlot.bind( this ), onMouseOut:this.onMouseOutInitPlot.bind( this )} );
    },

    // REQUESTS ********************************************************
    requestParametersByPlateform: function()
    {
        if( this.selectedPlateform )
            new Ajax.Request( "visualization?methodName=searchParametersByPlateform&id=" + this.selectedPlateform.getId(),
            {
                onSuccess:this.handleParametersBySelectedPlateform.bind( this )
            } );
    },

    // HANDLES ********************************************************
    handleParametersBySelectedPlateform: function( result )
    {
        this.jsonParameters = result.responseText.evalJSON().parameters;
        this.displayParameters();
    },

    // DISPLAYS ********************************************************
    displayPlateforms: function()
    {
        this.plateforms = new ListPlatforms( this.jsonPlateforms, new Object() );

        this.plateforms.addOpenListener( this.onSelectPlateform.bind( this ) );
        this.loadingPlateforms.hide();
        this.plateforms.displayWithPairImpair( this.containerPlateforms, "NoPlateform", interfaceTexts["data.visualization.noPlateform"] );

        // Select the first plateform by default
        if( this.jsonPlateforms && this.jsonPlateforms[0] )
        {
            var plateformToSelect = this.plateforms.getItemById( this.jsonPlateforms[0].id );
            this.onSelectPlateform( plateformToSelect.divItem );
            this.selectedPlateform = plateformToSelect.divItem;
        }
    },

    displayParameters: function()
    {
        var objectParameter = new Object();
        objectParameter.onMouseOverContainer = this.onMouseOverParameter;
        objectParameter.onMouseOutContainer = this.onMouseOutParameter;
        this.parameters = new ListParameters( this.jsonParameters, objectParameter );

        this.parameters.addOpenListener( this.onSelectParameter.bind( this ) );
        this.loadingParameters.hide();
        this.parameters.displayWithPairImpair( this.containerParameters, "NoParameter", interfaceTexts["data.visualization.noParameter"] );

        this.resizeContainers();
    },

    // EVENTS ********************************************************
    onSelectPlateform: function( objPlateform )
    {
        if( this.selectedPlateform && objPlateform.getId() == this.selectedPlateform.getId() )
            return;

        // Unselect old plateform
        if( this.selectedPlateform )
            this.selectedPlateform.unselect();

        this.selectedPlateform = objPlateform;
        this.selectedPlateform.select();

        // Unselect old parameter
        if( this.selectedParameter )
            this.selectedParameter = false;

        // Change axe's list select
        this.updateListAxes();

        this.addPlotButton.disable();

        $( "textareaTitle" ).value = this.selectedPlateform.getName();
        this.requestParametersByPlateform();
        this.testAllFields();
    },

    onSelectParameter: function( objParameter )
    {
        if( this.selectedParameter && objParameter.getId() == this.selectedParameter.getId() )
            return;

        // Unselect old parameter
        if( this.selectedParameter )
            this.selectedParameter.unselect();

        this.selectedParameter = objParameter;
        this.selectedParameter.select();

        // Change title
        $( "textareaTitle" ).value = this.selectedPlateform.getName() + " - " + this.selectedParameter.getName();

        // Update number and list of parameter to display
        this.updateNumberAndListParameterToDisplay( 1 );

        // Enable/disable addPlot's button
        if( !this.selectPlotsPlateformType || this.selectPlotsPlateformType == this.selectedPlateform.jsonElement.type )
            this.addPlotButton.enable();
        else
            this.addPlotButton.disable();

        this.testAllFields();
    },

    onMouseOverParameter: function()
    {
        this.divContainer.innerHTML = this.jsonElement.name + " (" + this.jsonElement.code + ")";
    },

    onMouseOutParameter: function()
    {
        this.divContainer.innerHTML = this.jsonElement.name;
    },

    onClickBeginDate: function()
    {
        var oneHour = 60 * 60 * 1000;
        var beginDateTime = this.calendarConverter.parse( $( "beginDate" ).value ).getTime();
        var endDateTime = null;
        if( "" != $( "endDate" ).value )
            endDateTime = this.calendarConverter.parse( $( "endDate" ).value ).getTime();
        this.beginDateWithAnHourLater = new Date( beginDateTime + oneHour );

        if( null == endDateTime || endDateTime < beginDateTime )
            $( "endDate" ).value = this.calendarConverter.format( this.beginDateWithAnHourLater );

        this.beginDate = this.calendarConverter.parse( $( "beginDate" ).value ).getTime();
        this.endDate = this.calendarConverter.parse( $( "endDate" ).value ).getTime();

        this.testAllFields();
    },

    onClickClear: function()
    {
        $( "beginDate" ).value = "";
        this.beginDate = false;
        $( "endDate" ).value = "";
        this.endDate = false;
    },

    onClickInitPlot: function()
    {
        this.updateNumberAndListParameterToDisplay( 0 );
    },

    onMouseOverInitPlot: function()
    {
//        this.initPlotButton.setValue(interfaceTexts["data.visualization.parameter.init"]);
    },

    onMouseOutInitPlot: function()
    {
//        this.initPlotButton.setValue(interfaceTexts["data.visualization.button.init"]);
    },

    onClickAddPlot: function()
    {
        this.updateNumberAndListParameterToDisplay( 2 );
    },

    onMouseOverAddPlot: function()
    {
//        this.addPlotButton.setValue(interfaceTexts["data.visualization.parameter.add"]);
    },

    onMouseOutAddPlot: function()
    {
//        this.addPlotButton.setValue(interfaceTexts["data.visualization.add"]);
    },

    onClickVisualize: function()
    {
//        this.plotWindow.getContent().innerHTML = '<div class="loadingPlot"><img src="/Megapoli/resources/icons/loading_datas.gif"/></div>';

//        var url = "visualization/plotEther?plateformId=" + this.selectedPlateform.getId()
//                + "&parameterId=" + this.selectedParameter.getId()
//                + "&dateBegin=" + this.beginDate
//                + "&dateEnd=" + this.endDate
//                + "&title=" + encodeURIComponent( $( "textareaTitle" ).value )
//                + "&axeType=" + this.selectAxes.getValue();

        var url = "visualization/plotEther?plateformId=14"
                + "&parameterId=90"
                + "&dateBegin=" + this.beginDate
                + "&dateEnd=" + this.endDate
                + "&title=" + encodeURIComponent( $( "textareaTitle" ).value )
                + "&axeType=" + this.selectAxes.getValue();

        this.plotWindow.getContent().innerHTML = '<img src=' + url + ' />';

//        this.plotWindow.getContent().innerHTML = '<applet width="500" height="200" code="AppletPlot.class">Now somewhere in the black moutains...</applet>';
        this.plotWindow.setSize( <%=EtherPlotServiceImpl.getMaxWidth()%>, <%=EtherPlotServiceImpl.getMaxHeight()%> );
        this.plotWindow.show();
    },

    onClickDownload: function()
    {
        if( this.testAllFields() )
            alert( "ok" );
        else
            alert( "non ok" );
    },

    // OTHERS ********************************************************
    resizeContainers: function()
    {
        var titleSize = document.getElementById( "nav" ).offsetHeight + document.getElementById( "title" ).offsetHeight + 30;
        var parentHeight = this.superParent.offsetHeight - titleSize;
        var containerPlateformsHeight = this.generalContainerParameters.offsetHeight;
        var containerParametersHeight = this.generalContainerParameters.offsetHeight;

        var containerPlateforms = this.containerPlateforms.offsetHeight;
        var containerParameters = this.containerParameters.offsetHeight;
        var containerOptionsHeight = this.generalContainerOptions.offsetHeight;

        var maxHeight = Math.max( containerPlateforms, containerParameters, containerOptionsHeight );

        this.superParent.style.height = maxHeight + titleSize + 35 + "px";
        this.generalContainerPlateforms.style.height = maxHeight + "px";
        this.generalContainerParameters.style.height = maxHeight + "px";
    },

    testAllFields: function()
    {
        if( !this.selectedPlateform || !this.selectedParameter || !this.beginDate || !this.endDate )
        {
//            this.visualizeButton.disable();
            this.downloadButton.disable();
            return;
        }

        this.visualizeButton.enable();
        this.downloadButton.enable();
    },

    updateListAxes: function()
    {
        this.selectAxes.clear();
        var jsonAxeTypes;

        if( "MOBILE" == this.selectedPlateform.jsonElement.type )
            jsonAxeTypes = this.jsonAxeTypesForMobilePlateforms;
        else
            jsonAxeTypes = this.jsonAxeTypesForFixedPlateforms;

        jsonAxeTypes.each( function ( axeType )
        {
            this.selectAxes.add( axeType.value, interfaceTexts[axeType.text] );
        }.bind( this ) );

        this.selectAxes.selectFirst( false );
    },

    /**
     * action = 0 --> init list
     * action = 1 --> select parameter
     * action = 2 --> add parameter
     */
    updateNumberAndListParameterToDisplay: function( action )
    {
        switch( action )
        {
            case 0:
                // INIT
                if( this.selectedPlateform && this.selectedParameter )
                {
                    this.selectPlots.clear();
                    this.selectPlotsPlateformType = false;
                    this.selectPlots.changeSelectMiddle( this.selectedPlateform.getId() + "-" + this.selectedParameter.getId(), this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );

                    this.numberParameterToDisplay = 1;
                    $( "messages_number_parameters" ).innerHTML = this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"];
                }
                else
                {
                    this.selectPlots.clear();
                    this.selectPlots.add( null, interfaceTexts["data.visualization.graph.noPlot"] );
                    this.selectPlots.selectFirst( false );
                    this.selectPlotsPlateformType = false;

                    this.numberParameterToDisplay = 0;
                    $( "messages_number_parameters" ).innerHTML = "";
                }
                break;
            case 1 :
                // SELECT
                if( 0 == this.numberParameterToDisplay )
                {
                    this.selectPlots.clear();
                    this.numberParameterToDisplay = 1;
                }

                this.selectPlots.changeSelectMiddle( this.selectedPlateform.getId() + "-" + this.selectedParameter.getId(), this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );
                $( "messages_number_parameters" ).innerHTML = this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"];
                break;
            default:
                // ADD
                var plotValue = this.selectedPlateform.getId() + "-" + this.selectedParameter.getId();
                if( !this.selectPlots.content( plotValue ) )
                {
                    this.selectPlots.add( plotValue, this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );
                    this.selectPlots.select( plotValue, false );
                    this.selectPlotsPlateformType = this.selectedPlateform.jsonElement.type;

                    this.numberParameterToDisplay = this.selectPlots.getSize();
                }

                $( "messages_number_parameters" ).innerHTML = this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"];
                break;
        }
    }

} )
        ;

</script>